# ****************************************************************************
# Surgeweb javascript - Primary Surgeweb javascript code
# supported by:
#	- sw_ui.js			: User interface handler functions		
#	- sw_core.js 		: Core "webmail" logic / server io code
# 	- sw_windowing.js	: Windowing / layout and display reformatting
#	- sw_util.js		: Utility functions
#	- sw_betapane.js	: Various things that should not be in the final product
#	+ a whole lot of supporting self contained javascript modules 
#   note: all files are optimised into a single compressed download "combined.js"
# ----------------------------------------------------------------------------
#  - Application initialisation
#  - Popup window only funcitons
#  - Various bits left over from development that still need tidying
# ****************************************************************************


dbg("surgweb js loaded");

# Webmail client logic
var enMSG=1, enFLD=2;

#Global surgeweb object for storage of mailclient level info
var sw = new Object;

# Primary Surgeweb "application intialisation" called after "interface outline" page is
# loaded but has not been populated with any user data yet.
function do_init()
{
	dbg('primary application init function');
	browser_id();
	ajax_init();
	prefs_validate();
	extend_init(1);
	column3_init();

	panelise();
	cache_dom_nodes();
	menubar_init('menu_bar_main');
	window_manager_init();
	app_menu_init();
	beta_testers_init();
	info_panel_init();
	sizers_init();
	extend_init(2);
	init_ui_elements()
#	// This does first and primary resize
	do_layout();
#	// This intentionally goes through timer (else eg sizers do not get correctly placed sometimes)
	do_resize();
	background_init();
	do_init_data();
	events_init();
	tweak_unfinished_stuff();
	touch(1);
	check_new_timed();
	xmenu_init();
	misc_init();
	bookmarking_init();
}


function prefs_validate()
{
	if (!pref.mode) pref.mode='app';
	if (!pref.preview) pref.preview=(pref.mode=='app'?'vert':'none');
	if (!pref.windows) pref.windows=(pref.mode=='app'?'popup':'inline');
	if (!pref.sounds) pref.sounds='all'; 	//pref_sounds
#	pref['confirm_no_ndelete']=false;
	sw.sort_type='date';
	sw.sort_rev='true';
}


function cache_dom_nodes()
{
	sw.msgs_pane=document.getElementById("messages"); //get_panel_node("messages","outer");
	sw.msgs_panelist=document.getElementById("messages_list");
	sw.msgs_preview=document.getElementById("message_preview");
#	sw.msg_pane=document.getElementById("message");

	sw.util=document.getElementById("utility");
	
	sw.menubar=document.getElementById("menubar");
	
	sw.search_input=document.getElementById("search_input");
	sw.search_limit=document.getElementById("search_limit");
	
	sw.status=document.getElementById("status");
	sw.busy=document.getElementById("busy");
}


function do_init_data()
{
	sndReq("cmd=show&page=~login.js&rev="+sw.sort_rev, function(chan){
		sw.fld_type=1;
		sw.fid='INBOX';
		actionReqJs(chan);			
		switch_selfld('INBOX');
		hide_loading();
		msgdnd_init();
	});
}

function events_init()
{
	document.onkeydown=function(e){
		var ret=true;
		var last_mid;
		if (!e) e = window.event;
		if (!e) return;
# 		Keycode identification code
		touch(2);
#		if (true){
			dbg("keycode="+e.keyCode+" shiftKey="+e.shiftKey+" ctrlKey="+e.ctrlKey+" altKey="+e.altKey+" metaKey="+e.metaKey );
#			stop_def_action(e);
#			return false;
#		}
		if(e.keyCode==9) {
			dbg("*** tab in main window");
			if(qq){
				dbg("*** tab in main window KILLED");
				qq=false;
				stopEvent(e);
				return false;
			}
		}

		if (!sw.active) return;
#		dbg("keycode="+e.keyCode);	// NOKEYS!!
#		if (e.shiftKey==true && class_contains(sw.active,'fldmsg')){
#		Chrome 1.0 returns metakey on altKey!!
		var metakey=e.metaKey && !e.altKey;
		if (pref.mode=='app' && class_contains(sw.active,'fldmsg')&&!metakey){
			switch (e.keyCode){
#			up arrow:
			case 38: if (e.ctrlKey&&e.altKey){
					 	pref.message_done_action='prev';
					 	return;
					 }
					 if (e.shiftKey) {
					 	 if(cursor_row) row_select(cursor_row,true);				 	 
						 sw.b4select=false;
						 last_mid=cursor_mid;
					 }else{
						 select_none_fast();
					 }
					 show_soon(show_prev_real(cursor_mid,false),e.shiftKey);
					 if(e.shiftKey && sw.b4select)
					 	row_unselect(sel_to_row(dge('sel_'+last_mid)));	
					 ret=false;
#					 shift_sel_start=null;
					 break;
# QQSEL ARROW
#			down arrow:
			case 40: if (e.ctrlKey&&e.altKey){
					 	pref.message_done_action='next';
					 	return;
					 }
					 if (e.shiftKey) {
					 	 if(cursor_row) row_select(cursor_row,true);				 	 
						 sw.b4select=false;
						 last_mid=cursor_mid;
					 }else{
						select_none_fast();
					 }
					 show_soon(show_next_real(cursor_mid,false),e.shiftKey);
					 if(e.shiftKey && sw.b4select)
					 		row_unselect(sel_to_row(dge('sel_'+last_mid)));	
					 ret=false;
#					 shift_sel_start=null;
					 break;
					 
#			left arrow 37
#			pg up 33
#			right arrow 39
#			pg dwn 34
#			up arrow 38
#			down arrow 40
#			case 38: if(sw.util.fldmsg_current==enMSG)
#						layout_fldmsg(enFLD);
#					 break;	

#			r / Ctrl+R - reply
			case 82: 
					if (true /*e.ctrlKey*/) {do_reply();ret=false;}
					break;
#			f - forward
#			Ctl+Shift+F - quick search					
			case 70: if (!e.ctrlKey) {do_forward();ret=false;}
					if (e.ctrlKey && e.shiftKey) {dge('search_input').focus();ret=false;}
					break;
#			n - Compose new message
			case 78: 
					if (!e.ctrlKey) {do_compose(e);ret=false;}
					break;

#			q - quick search (or / or Ctl+Shift+F)
			case 81:
			case 191:dge('search_input').focus();ret=false;
					break;

#			ctl A - disable default select all 
			case 65: 
					 if (e.ctrlKey) {
						ret=false;
					 }else{
					 	do_reply_all();
					 }
					 break;
#			ctl shift 1-6 - single keystroke filing
			case 49:		 
			case 50:		 
			case 51:		 
			case 52:		 
			case 53:		 
			case 54:
					if(!(e.shiftKey&&e.ctrlKey)) break;
					var fld=keymap[e.keyCode-48];
					if(fld && fld.length>0)do_move_actual(fld);
 					break;
					 
			}
		}else{
			msg_menu_events(e);
		}
		
		return ret;
	}

	dge("messages").onkeydown=function(e){
		if (!e) e = window.event;
		if (!sw.active) return;
		if (pref.mode=='app' && class_contains(sw.active,'fldmsg')){
#			touch(3);
			switch (e.keyCode){
#			enter - show message (in keydown as keyup received after pressing enter on a dialog)
			case 13:
					if (cursor_mid){
						show_msg(cursor_mid,e);	
					}
					break;	
#			ctl A - select all 
			case 65:
					if (e.ctrlKey) {
						 if (e.shiftKey)
							 do_select('none');
						 else
							 do_select('all');
						stop_def_action(e);
						return false;
					}
					break
#			ctl Z - Cache messages
			case 90: 
					 if (e.ctrlKey) {
						 if (e.shiftKey){
							 do_select('all');
							 do_cache();
							 do_select('none');
							 msglist_select(cursor_mid);
						 }else{
						 	do_cache();
						 }
					 }
					 break;
			}
		}
	}
	dge("messages").onkeyup=function(e){
		var ret=true;
		if (!e) e = window.event;
		if (!sw.active) return;
		dbg("keycode XX="+e.keyCode);
		if (pref.mode=='app' && class_contains(sw.active,'fldmsg')){
			switch (e.keyCode){
#			delete / backspace - delete message(s)
			case 8: // OSX delete key (I believe - but backspace onthe PC!!!)
			case 46: do_delete(e.shiftKey);
					 ret=false;
					 stop_def_action(e)
					 break;
#			esc - select none
#			case 27: 
#					 do_select('none');
#					 break;
			}			
		}
		return ret;
	}
	document.oncontextmenu=main_contextmenu;
}

function msg_menu_events(e)
{		
#	if('message window' check) - not ideal but this will do for now
	if (!sw.menubar.current) return;
	var isMessage=(sw.menubar.current.id=="menu_message");
	var isEdit=(sw.menubar.current.id=="menu_compose");

	if(isEdit) {
		switch (e.keyCode){
#		escape:
		case 27: 
				if(sw.active.unsaved){
					edit_discard();
					break;
				}
				if (sw.active.tab_ref)
					tab_close(sw.active.tab_ref.id);
				break;
#		Enter
		case 13: if (e.ctrlKey){
					if (e.shiftKey)
						do_send_move();
					else
						do_send();
				}
				break;
#		Ctrl+S - save draft
		case 83: if (e.ctrlKey){
					do_save_draft(undefined,function(){sw.active.unsaved=false});
				}
				break;
		}		
	}

	if(isMessage) {
		switch (e.keyCode){
#		escape:
		case 27: 
				if (sw.active.tab_ref)
					tab_close(sw.active.tab_ref.id);
				break;

#		r / Ctrl+R - reply
		case 82: 
				do_reply(e);
				break;
#		f - forward
		case 70: if (!e.ctrlKey) do_forward();
				break;
#		a - reply all
		case 65: 
				 if (!e.ctrlKey) do_reply_all();
				 break;
#		Ctrl+up arrow - prev message
		case 38: 
				 if (e.ctrlKey) show_prev(sw.is_popup?sw.mid:cursor_mid);
				 break;
#		Ctrl+down - next message
		case 40: 
				 if (e.ctrlKey) show_next(sw.is_popup?sw.mid:cursor_mid);
				 break;
		}
	}
}

function editor_keypress(e){
	if (!e) e = ew.event;
#	dbg("keypress in editor window - code="+e.keyCode);		// NOKEYS!!
}

function editor_keydown(e){
	if (!e) e = ew.event;
#	dbg("keydown in editor window - code="+e.keyCode);			// NOKEYS!!
	switch (e.keyCode){
#	Make tab in editor indent text / move to subject edit field
		case 9:
				if (e.shiftKey){
					sw.active.field_subject.focus();
				}else{
					if(isIE){
						var xwin=(sw.active ? sw.active.field_eframe.contentWindow : document.getElementById('eframe1').contentWindow);
						var sel = xwin.document.selection.createRange();
						sel.pasteHTML('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
					}else if(isSafari){
#						//Safari on OSX must not stop this event!! 
						return;
					}else{
#						editor_do('insertHTML','<span class=\"tab-span\" style="white-space:pre">&#0009;</span>');
						editor_do('insertHTML','&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
					}	
				}
				stopEvent(e);
				return false;
				break;
	}
}
var qq=false;
function editor_keyup(e){
	if (!e) e = ew.event;

#	dbg("keyup in editor window - code="+e.keyCode);			// NOKEYS!!
	touch(4);
	switch (e.keyCode){
#		Enter
		case 13: if (e.ctrlKey){
					if (e.shiftKey)
						do_send_move();
					else
						do_send();
				}
				spellcheck_markup_removeall();
				break;
#		Escape
		case 27: 
#					Grab focus back from iframe and then discard
				window.focus();
				edit_discard();
				break;

#		shift tab
#		case 9:
#				if (e.shiftKey){
#						window.focus();
#					sw.active.field_subject.focus();
#				}else{
#					dbg("*** tab in editor");
#				}
#				break;
#		Ctrl+S - save draft
		case 83: if (e.ctrlKey){
					do_save_draft(undefined,function(){sw.active.unsaved=false});
				}
				break;

#		space character
#		case 32:
#				spellcheck_markup_remove(e);
#				drop through to default				
		default:
#				clear_spellcheck_squiggle(e);
#				dbg('** default unsaved='+sw.active.unsaved)
				sw.active.unsaved=true;
				if(!autosave_timer){
					dbg('** starting autosave timer')
					autosave_timer=setTimeout(draft_autosave,(pref.devt_mode?4:120)*1000);
				}
				break;
	}
//		updateTimer();
}		

var autosave_timer;
function draft_autosave()
{
	autosave_timer=null;
	if(sw.menubar.current.id!="menu_compose") return;
	if(sw.active.unsaved){
		do_save_draft(true,function(){sw.active.unsaved=false});
	}
}



function popup_keydown(e)
{
	if (!e) e = window.event;
	if (!e) return;
	msg_menu_events(e);

#	dbg("keycode="+e.keyCode);		// NOKEYS!!
}

document.onclick=function(e){
	if (!e) e = window.event
	if (!e) return;
	
	if (global_active_menu)
		menu_hide2(global_active_menu);


	var t = target(e);
	if (t.tagName=="A"){
		dbg('clicked on link id='+t.id+' href='+t.href);

//		stopEvent(e);

		return;
		if (t.href.substring(0,7)=="http://" && !confirm("This links to an external page. Any unsaved data will be lost. Are you sure?")){
			return stopEvent(e);
		}
	}
}

function edit_subject_keydown(e)
{
	switch (e.keyCode){
#	enter - eat enter keys to prevent default form actions in edit fields
	case 13:
			focus_next_surgeweb_edit_ctl(target(e));
			stopEvent(e);
			return false;
			break;	
	}
}

# ***** Functions for use from popup msg / edit window only *****

function do_popup_init()
{
	sw_win = window.opener;
#	// Make sure that the object in or calling window has been instanciated
	var pp=sw_win.pending_popups[window];
	if (!pp){
		setTimeout(do_popup_init,20);
		return;
	}

	dbg('attaching debug output to main window for central logging');
	dbg=sw_win.dbg;
	dbg('*** POPUP message window attached ***');
	
	browser_id();

	sw.util=document.getElementById("utility");
	sw.menubar=document.getElementById("menubar");

	var container=document.getElementById('message_container');
	container.popup_message=document.getElementById('message_panel');
	container.popup_compose=document.getElementById('compose_panel');
	container.popup_message.container=container.popup_compose.container=container;

	sw.active=container.popup_message;

	if ('||panel_mode||'=='orig_x'){
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_square(container.popup_message,enBody3);
		panelise_square(container.popup_compose,enBody3);
		panelise_square(document.getElementById('sw_footer'),enBot);
	}else{
		panelise_plain(document.getElementById('menubar'),enHdr);
		panelise_plain(container.popup_message,enBody3);
		panelise_plain(container.popup_compose,enBody3);
		panelise_plain(document.getElementById('sw_footer'),enBot);
	}

#	document.getElementById("sid").innerHTML = sw_win.sid;
	sw.is_popup=true;

	sid = sw_win.sid;
	sw.type = pp['type'];
	sw.jmsg = pp.jmsg;
	// Possible remove these two
	sw.mid = pp.jmsg.cache_mid;
	sw.fid = pp.jmsg.fld;

	if(sw_win.skin.length>0){
		load_dynamic_css('||www_base||shared/skins/'+sw_win.skin+'/skin.css?||vz||');
	}

#	this all seems a bit juck and maybe should be store in one place??	
	pref_reply=sw_win.pref_reply;
	class_add(document.body,sw_win.pref_colour);
	email=sw_win.email;
	signature=sw_win.signature;

	sw.jmsg.instance=sw_win.instance;
	unique_instance(document.getElementById('message_container'), sw_win.instance++);

	window.onbeforeunload=function(){if(sw.type=='edit'&&!sw.closing) return "";}
	document.onkeydown=popup_keydown;
	document.oncontextmenu=main_contextmenu;

	show_xxx_complete_popup();
	init_ui_elements();
	popup_resize();
}

function popup_resize(){
	xx['mnu_h']=panel_correct(sw.menubar).offsetHeight+3;
	xx['screen_h']=ClientHeight();
	
	if (sw.type=='msg'){
		sw.active.style.height=px(xx['screen_h']-(xx['mnu_h']+footer)); 
	}else{
		xx['chdr_h']=sw.active.compose_header.offsetHeight;
		sw.active.field_eframe.style.height=px(xx['screen_h']-(xx['mnu_h']+xx['chdr_h']+footer)-||panel_gap||);
	}
}
function do_delete2(id)
{
	var sel=make_sel(sw.fid,id);
	set_status("Deleting...","info");
	ajax_delete(sel);
}

function do_move2(id)
{
	var sel=make_sel(sw.fid,id);
	set_move_status(sel,t.fname);
	ajax_msg_move(sel,t.fname);
}

function set_move_status(sel,fld)
{
	set_status('Moving to '+fld+'...',"info");
}

# Message list cursor / primary selection handling
#  note these will not always match!! 
#  Ideally I'd only have one but can't decide which would be best for efficiency.
var cursor_mid, cursor_row;	

# ****************************************************************
# Stuff left over from development I've not cleaned up yet... Not sure how much is essential


var temp_stuff;
var window_list;
var window_uid=0;

var banner_height=||banner_height||;
#var left_column=145;
var right_column=0;
var footer=0;	//22
var pane_ratio=0.5;

var instance=1;
inline_loading='msg';

x_M_param=false;

# Original show message code - only still used for preview display I believe old function M(
function show_preview(mid, extra, type, nofocus, nostatus)
{
	dbg("Message id=="+mid+" display 1");

	if (seen_timer) clearTimeout(seen_timer);

#	var destination=(window.event && window.event.shiftKey)?'message':'message_preview';	
	var destination=(pref.mode=='app'?'message_preview':'message');	
	dbg("destination="+destination)
	if (x_M_param) {destination='message';x_M_param=false;}

	destination='message_preview';
	
	if (destination!='message_preview') {
		fldmsg_display(enMSG);
		sw.msg_pane.menu_ref=sw.menubar.menus["menu_message"];
		window_manager_newtab(sw.msg_pane,'message');
	}
	
	cursor_mid=mid;
	if(sw_cache && sw_cache[sw.fid+'_'+mid]){
		dbg("attempting to load message id="+mid+" from cache");
#		actionReqSethtmlStat(sw_cache[sw.fid+'_'+mid],destination);			
#		dge(destination).innerHTML=sw_cache[sw.fid+'_'+mid].html;
		var qmsg=sw_cache[sw.fid+'_'+mid];
		assign_destination_html(destination,mid,html_from_qmsg(qmsg));
		special_processing(destination,qmsg);	
		if (class_contains(sel_to_row(document.getElementById('sel_'+cursor_mid)),'msg_unread')){
			var sel=make_sel(sw.fid,mid);
			seen_timer=setTimeout(function(){set_seen(sel)},(type=='initial'?7000:2500));
		}			
	}else{
		if (!extra) extra="";
		set_loading(destination);
		retrieve_msg(sw.fid,mid,function(chan){M_cb(chan,destination,type,mid);},extra,nostatus);
#		sndReq('cmd=show&page=~msg.js&msg_id='+mid+"&fld_id="+sw.fid+extra, function(chan){M_cb(chan,destination,type,mid);});
	}
	if (pref.mode=='web') 
		do_select('none');
	if(type!='initial')
		msglist_select(mid,undefined,nofocus);	
}

function M_cb(chan,destination,type,mid)
{
	doneloading();
	var success=actionReqJsStat(chan);
	var idx=sw.fid+'_'+mid;

	cache_add(idx,amsg);
	var qmsg=sw_cache[idx];
	assign_destination_html(destination,mid,html_from_qmsg(qmsg));
#	dge(destination).innerHTML=amsg.html;
#	actionReqSethtmlStat(chan.responseText,destination);
#	if (global_auth_error) {
#		global_auth_error=false;
#		return;
#	}
	special_processing(destination,qmsg);	
	//fire of a "read" "request"
	var el=document.getElementById('sel_'+mid);
	if (!el) return;
	if (class_contains(sel_to_row(el),'msg_unread')){
		var sel=make_sel(sw.fid,mid);
		seen_timer=setTimeout(function(){set_seen(sel)},(type=='initial'?7000:2500));
	}			
}

function Mx(txt)
{
	fldmsg_display(enMSG);
	sw.msg_pane.innerHTML='<div class="nomessages">'+txt+'</div>';
}


# Old style display layout - still partly used

// (Restore the fldmsg display if somethign else is shown)
// (and make sure that an acceptable msg / fld pane is actually visible)
function fldmsg_display(type)
{
	var a
	var util=sw.util;

	dbg('fldmsg_display');

#	Minimise any other displays
	if(util.active && !class_contains(util.active,'fldmsg'))
		window_manager_minimise(util.active);
#	If no request, just switch back to last
	if (type==undefined){
		type=util.fldmsg_current;
	}
# 	If there is a reques but last is on, just switch back to last	
	if (type&util.fldmsg_current)
		type=util.fldmsg_current;
#	Actually layout the panes		
	layout_fldmsg(type);
}
// Arranges the folderlist and message display mode dependant on preferences
function layout_fldmsg(mode)
{
	var oldmode=sw.util.fldmsg_current;

	var maintab=sw.msgs_pane.tab_ref;
	if(!(class_contains(panel_correct(maintab),'selected'))){
		window_manager_minimise(sw.active,true);
		restoreMsgFromTab(maintab);
	}	
#	dbg('layout_fldmsg early');
	if (!sw.msgs_pane) {alert("not init");return;}
	
	if (mode>0) 
		sw.util.fldmsg_current=mode;

	dbg('layout_fldmsg mode='+mode);

#	// All hidden
	if (mode==0){
		class_add(panel_correct(sw.msgs_pane),'hidden');
#		class_add(panel_correct(sw.msg_pane),'hidden');
		sw.active=undefined;
	}
#	// List only display	
	else if(mode==enFLD){					
		menu_set("menu_bar_main");
		class_remove(panel_correct(sw.msgs_pane),'hidden');
		sw.msgs_panelist.style.height="";
#		class_add(panel_correct(sw.msg_pane),'hidden');
		sw.active=sw.msgs_pane;
	}
#	// Message only display	
	else if(mode==enMSG){
		menu_set("menu_message");
		class_add(panel_correct(sw.msgs_pane),'hidden');
#		class_remove(panel_correct(sw.msg_pane),'hidden');
#		sw.msg_pane.style.height="";
#		sw.active=sw.msg_pane;
	}
}

# This is a bit of a hack... but will do for now, lets see if we can improve later
function tweak_unfinished_stuff(){
	var o;
	o=dge("app_menu"); if (o) set_panel_bottom_border_color(o,"#8FC1E6")
	o=dge("beta_panel"); if (o) set_panel_bottom_border_color(o,"#FFFFD1")
}

# ** Still used to update the main central pane **
var util_body_style = enBody3;
function panel_show_old(id,resize)
{
#	window_manager_minimise(sw.active,true);
	var menu=menu_set(id+"_menu");
	var panel=document.getElementById(id+'_panel');
	if (pref.panelise)
		panelise_square(panel,util_body_style);
	panel.menu_ref=menu;
	sw.active=panel;
	sw.active.resize=resize;
	do_resize_real();
}
function panel_show_old2(id)
{
#	var menu=menu_set(id+"_menu");
	var message=document.getElementById('message_panel');
	var compose=document.getElementById('compose_panel');

	message.parentNode.sw_message=message;
	compose.parentNode.sw_compose=compose;

	if (pref.panelise){
		panelise_square(message,util_body_style);
		panelise_square(compose,util_body_style);
	}
	message.menu_ref=sw.menubar.menus["menu_message"];
	compose.menu_ref=sw.menubar.menus["menu_compose"];
	menu_set("menu_message");
#	setTimeout('init_editor("eframe");',100);	
	sw.active=message;
	do_resize_real();
}


# *** Core layout switching routine (NEEDS TIDYING) ***

# Window layout variables
var layout_type;
var preview=false;

var list_h=0;
var count=1;
var last_cc_h=-1;

function do_layout()
{
	dbg('>> do_layout');

#	if (type.length<1) type="a2v";
#	if (type==layout_type) return;

	var mnu=document.getElementById("layout_menu");
	var ml=document.getElementById("messages_list");
	var ml_bx=document.getElementById("msglist_box");

	var msg_p=document.getElementById("message_preview");
	var sz2=document.getElementById('sizer2')
#	var div3=document.getElementById("message_preview");
	class_add(mnu,'hidden');

# 	convert new preferences into old set call (function below should be rewritten, to not need this)
	var type='';
	switch(pref.mode){
		case'app':type+='a';break;
		case'web':type+='w';break;
	}
	switch(pref.preview){
		case'horiz':type+='2h';break;
		case'vert':type+='2v';break;
		case'none':type+='1';break;
	}
		
	if (type=='w1') { 
		layout_fldmsg(enFLD); 
		class_add(msg_p,'hidden'); 
		class_remove(ml_bx,'a2h_list'); 
		ml_bx.style.height="";
		ml_bx.style.width="";
	}
	if (type=='a1') { 
		layout_fldmsg(enFLD); 
		class_add(msg_p,'hidden'); 
		class_remove(ml_bx,'a2h_list'); 
		ml_bx.style.width="";
#		preview=false;
	} 
	if (type=='a2h') { 
		layout_fldmsg(enFLD); 
		class_remove(msg_p,'hidden'); 
		class_add(sz2,'hidden'); 
		class_add(ml_bx,'a2h_list'); class_remove(msg_p,'a2v_msg');
	}
	if (type=='a2v') { 
		layout_fldmsg(enFLD); 
		class_remove(msg_p,'hidden'); class_remove(sz2,'hidden'); 
		class_remove(ml_bx,'a2h_list'); class_add(msg_p,'a2v_msg');
	}
	
#	if (layout_type){
#		pref_layout=type;
#		ajax_pref_save('pref_layout='+pref_layout);
#	}
	layout_type=type;

	if (type.indexOf('2')!=-1){
#		class_remove(sz2,'hidden');
		var x_list=document.getElementById('msglist_box')
		var x_ban=document.getElementById('top_banner')
		var x_mnu=panel_correct(document.getElementById('menubar'))
#		x.style.top=(q.offsetTop+x_list.offsetHeight)+'px';
		if (type=='a2v') {
#			sz2.style.top=(x_ban.offsetHeight+x_mnu.offsetHeight+x_list.offsetHeight+2)+'px';			
			dbg("*** ban="+x_ban.offsetHeight+' mnu='+x_mnu.offsetHeight+' list='+x_list.offsetHeight)
			preview='v';
		}else{
			preview='h';
		}
	}else{
		class_add(sz2,'hidden');
		preview=false;
	}
	
	var switcher=document.getElementById('switcher');
	if (pref.windows=='tabbed'){
		class_remove(switcher,'hidden');
	}else{
		class_add(switcher,'hidden');
	}	

	// temporary for debugging
	if (pref.windows=='inline'){		
		class_remove(document.getElementById('msg_menu_back'),'hidden');
		if(pref.devt_mode){
			class_remove(switcher,'hidden');
			switcher.style.background='red';
		}
	}

	do_resize_real();
}

function app_menu_init()
{
	if (pref.no_blogs)
		class_add(document.getElementById("app_blogs"),'hidden');
	if (pref.no_surgeplus){
		class_add(document.getElementById("app_calendar"),'hidden');
		class_add(document.getElementById("app_photos"),'hidden');
	}
	app_menu('mail',dge('app_menu_mail'));
}

# QQSEL
var first_message='';
function set_first_message(id,keep_selection)
{
#	alert(keep_selection+' '+id);
	if(istrue(keep_selection)){
		first_message=id;
	}else{
		dge('message_preview').innerHTML='<div class="nomessages">No message has been selected !!!.</div>';	
		if(id.length>0 && pref['message_done_action']!='none'){
			msglist_select(id);
			show_preview(id,'','initial');
		}
	}
}
function set_folders(txt)
{
	var el=document.getElementById('folders');
	el.innerHTML=txt;
	el.onclick=folder_click;
	clear_folder_menu('folder_menu');
#	dge('moveto_folder2').innerHTML='';
}


# for now source the addressbook information for autocompletion from surgeplus instead of surgeweb
function get_addresses_temporary()
{
#	var url='http://127.0.0.1/surgeplus/web?utoken='+utoken+'&cmd=sp_address_book&fname=surgeplus_surgeweb_abk.js';
#	url.replace(/&/g,"%26");
	var url='||webmail_port_url||/surgeplus/web?utoken='+utoken+'%26cmd=sp_address_book%26fname=surgeplus_surgeweb_abk.js';
	queued_req_add( enBG, function(){
		sndReq('cmd=proxy&url='+url, function(chan){
			if(chan.responseText.indexOf('surgeplus_surgeweb_abk.js')==-1){
				set_status("Address autocompletion download failed <br>(surgeplus session probably expired, by other surgeplus client or other surgeweb login)",'warning');
			}else{
				var success=actionReqJsStat(chan);
			}
		},ch[enBG]);
	});
}



function check_new_mail()
{
	queued_req_add( enBG, function(){
		sndReq('cmd=check_mail,show&page=~result.js', function(chan){
			var success=actionReqJsStat(chan);
		},ch[enBG]);
	});
}

function new_mail(n,ids,updating)
{
	set_status(n+' new message'+(n>1?'s':'')+' received!'+(updating?'':' <a href="#" onclick="F(\'INBOX\',\'1\',undefined,true)">refresh inbox</a> to view messages'),'success');
	if (pref.sounds=='new' || pref.sounds=='all') 
		play_sound('new');
	
#	var sel=make_sel(fld,mid);
	var sel=[ids];
 	sel.fid='INBOX';
 	sel.fld_type=1;
	ajax_cache_messages(sel,true);
}

var checknew_timer;
var checknew_next;
function check_new_timed()
{
	if (pref.nocheck) return;
	
	var t=time();
	var untouched=t-sw.last_action;

	if(untouched<60){
		wait=20;
	}else if (untouched<10*60){
		wait=60;
	}else{
		wait=5*60;
	}

	checknew_next=t+wait;
	dbg('Last user action '+untouched+'s ago, new mail check in '+wait+'s');
	checknew_timer = setTimeout(function(){
		dbg('checking new mail')
		check_new_mail();
		check_new_timed();
	},wait*1000);
}
# ***



function vtab_init(prefix,item)
{
	var divs=document.getElementById("options_tabs").getElementsByTagName('div');
	for(var i=0;i<divs.length;i++){
		id=divs[i].id;
		if(id.substring(0,2)=="ot") class_remove(divs[i],"selected");
		if(id.substring(0,2)=="ob")	class_add(divs[i],"hidden");
	}
	class_add(document.getElementById("ot"+item),"selected");
	class_remove(document.getElementById("ob"+item),"hidden");
}



function upload_init(node) {
	var settings = {
		flash_url : "||www_base||shared/modules/swfupload.swf",
		upload_url: '/surgeweb?cmd=attach_upload,show&sid='+sid+'&if=ajax&page=~result.js',	// Relative to the SWF file

		button_width: sw.active.button_place_holder.nextSibling.offsetWidth,
		button_height: sw.active.button_place_holder.nextSibling.offsetHeight,
		button_placeholder_id: 'spanButtonPlaceHolder'+sw.active.instance,
#		button_text: '<span class="theFont">Hello</span>',
#		button_text_style: ".theFont { font-size: 16; }",
#		button_text_left_padding: 12,
#		button_text_top_padding: 3,

		post_params: {'attach_mid' : sw.active.jmsg.attach_mid, 
					  "PHPSESSID" : "<?php echo session_id(); ?>", 	// Various bits of crap to be removed
					  "comment":"Some other thing like comment"},
		file_size_limit : "100 MB",
		file_types : "*.*",
		file_types_description : "All Files",
		file_upload_limit : 100,
		file_queue_limit : 0,
		custom_settings : {
			progressTarget : node.attach_progress.id,
			cancelButtonId : "btnCancel"
		},
		debug: false,


		// The event handler functions are defined in handlers.js
		file_queued_handler : fileQueued,
		file_queue_error_handler : fileQueueError,
		file_dialog_complete_handler : fileDialogComplete,
		upload_start_handler : uploadStart,
		upload_progress_handler : uploadProgress,
		upload_error_handler : uploadError,
		upload_success_handler : uploadSuccess,
		upload_complete_handler : uploadComplete,
		queue_complete_handler : queueComplete	// Queue plugin event
	};
	
#	// Safari & FF do not these cookies through Flash, so do ourselves
#	//  but the following does not work under IE!! go figure.... at least it does enough to do what I want  :-)
	var s=get_cookie("SW-AUTHTOKEN");
	if (s) settings.post_params['SW-AUTHTOKEN']=s;

	node.swfu = new SWFUpload(settings);
	node.swfu.sw_panel=node;
}


# **** 

function do_exta_status()
{
	alert("Should show a history of status messages, state of communication channels, account quota etc")
}


function attachment_status(node,o)
{
	node.innerHTML=o.length+' file'+(o.length==1?'':'s')+' attached';
}

function attachment_add(node,att)
{
	if(sw.is_popup) return sw_win.attachment_add(node,att);

	var jmsg=node.jmsg;

	if (!jmsg.attach_ids){
		jmsg.attach_ids=[];
		jmsg.attach_info=[];		
	}
	jmsg.attach_ids.push(att[1]);
	jmsg.attach_info.push(cloneObject(att));
}
function attachment_remove(node,id)
{
	var jmsg=node.jmsg;
	var i=my_indexOf(jmsg.attach_ids,id);
	if(i!=-1){
		jmsg.attach_ids.splice(i,1);
		jmsg.attach_info.splice(i,1);
	}
	attachment_status(node.attach_status,jmsg.attach_ids);
}
function do_attach()
{
	alert("should do form based old style attachment upload as flash does not seem to be available")
}
function do_attach_init()
{
	if(sw.active.jmsg.action=='redirect'){
		alert('Redirected messages cannot be modified');
		return;
	}

	attachments_init();
	
#	attach_retries=0;
#	do_attach_step2();
}
function attachments_init()
{
	dbg('attachments button pressed')

	var o=sw.active.attachments
	if (class_contains(o,'hidden')){
		class_remove(o,'hidden');
		
		if(sw.is_popup){
			popup_resize();
		}else{	
			do_resize_real();
		}
	}
	if(!sw.active.swfu){
		setTimeout(function(){upload_init(sw.active);},10);
#		upload_init(sw.active);
	}else{
		alert("Press the 'Attach new from Local' button to upload one or more files");
	}
}

var attach_retries;
function do_attach_step2()
{
	return;
#	if(sw.active.swfu.PercentLoaded()<100){
#		if(attach_retries<100){
#			attach_retries++;
#			setTimeout(do_attach_step2,50);
#			return;
#		}
#	}
	
	try {
		sw.active.swfu.selectFiles();
	} catch (ex) {
		alert(ex);
		if(attach_retries<100){
			attach_retries++;
			setTimeout(do_attach_step2,50);
			return;
		}
		x_alert("Could not enable attachment upload interface. Note: Adobe Flash needs to beinstalled to attach files.");
		dbg('attachments interface could not be initialised')
	}	
}
function do_attach_removeall()
{
	var node = sw.active;
	node.swfu.cancelQueue();
	node.attach_progress.innerHTML="";
	node.jmsg.attach_ids=[];
	dbg('attachment remove all pressed')

	attachment_status(node.attach_status,node.jmsg.attach_ids);
}



function get_cookie(name) {
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    } else {
        begin += 2;
    }
    var end = document.cookie.indexOf(";", begin);
    if (end == -1) {
        end = dc.length;
    }
    return unescape(dc.substring(begin + prefix.length, end));
}


function xmenu_init(){
	xmenu_register_jshover(dge('top_menu_options'));
	xmenu_register_jshover(dge('pg_menu_select'));
	xmenu_register_jshover(dge('pg_menu_sort'));
	xmenu_register_jshover(dge('pg_menu_display'));
}


function update_unread(box,txt)
{
	var el=dge('unread_'+box);
	if (!el) return;
	el.innerHTML=txt;
}


function navigator_set(first,count,total,txt)
{
	var o=dge('msg_navigator'); 
	if (o) o.innerHTML=txt;
	sw.nav_first=first;
	sw.nav_count=count;
	sw.nav_total=total;
#	dbg("*** Nav_set "+sw.nav_first+':'+sw.nav_count+':'+sw.nav_total)
}

function navigator_update()
{
	var o;
	if(sw.nav_total>0){
		o=dge('nav_first'); if (o) o.innerHTML=sw.nav_first;
		o=dge('nav_total'); if (o) o.innerHTML=sw.nav_total;
		o=dge('nav_last'); if (o) o.innerHTML=sw.nav_first+sw.nav_count-1;
	}else{
		o=dge('msg_navigator'); if (o) o.innerHTML='';
		no_msg_sel();
	}
	if(sw.nav_count==0&&sw.nav_total>0 || sw.nav_count<50&&sw.nav_total!=sw.nav_count){
		var start = (sw.nav_first+100<sw.nav_total) ? sw.nav_first-1 : sw.nav_total - 100;
		F(sw.fid,sw.fld_type,start,false,true);
	}

#	dbg("*** Nav_update "+sw.nav_first+':'+sw.nav_count+':'+sw.nav_total)
#	if(dge('nav_first')) dbg("*** Nav_update "+dge('nav_first').innerHTML+' - '+dge('nav_last').innerHTML+' of '+dge('nav_total').innerHTML  )
}

function touch(id)
{
#	dbg("** touch "+id);
	sw.last_action=time();
	var wait=checknew_next-sw.last_action
	if(wait>20){
		dbg("touch "+id+" - changing checknew_timer from "+wait+"s to 20s");
		clearTimeout(checknew_timer);
		check_new_timed();
	}
}

# Mostly seems to stop the one pixel shift which clicking links in IE sometimes has
#   todo look for better fix	
function stop_shift()
{
	if(isIE) {
		e=window.event;
		if (!e) return;
		stopEvent(e);
	}
}

function contact_click(email,name)
{
	if(sw.is_popup) return sw_win.contact_click(email,name);
	do_new_email(name,email);
}
function contact_click_old(email,name)
{	
	if(sw.is_popup) return sw_win.contact_click_old(email,name);
	var extra='&old_nickname=&contact_nickname='+xescape(encode_quotes(email))+'&contact_email='+xescape(encode_quotes(email))+'&contact_name='+xescape(encode_quotes(name));
#	queued_req_add( enBG, function(){
		sndReq('cmd=contact_add,show&page=~result.js'+extra, function(chan){
#			if(chan.responseText.indexOf('no such template')!=-1){
#				set_status("Contact save failed (probably already in addressbook)",'warning');
#			}else{
				var success=actionReqJsStat(chan);
				if(success){
					set_status('Contact '+email+' added to addressbook',"success")
				}else{
					set_status('Contact save failed ('+success_string+')','warning');
				}
//			}
		});
#		},ch[enBG]);
#	});	
}


function shiftkey(){
	var o=window.event;
	if (!o) return false;
	return o.shiftKey;
}

function no_msgs_fld()
{
	setMessages('<span><div class="nomessages">There are no message in this folder.</div></span>');
}
function no_msg_sel()
{
	dge('message_preview').innerHTML='<div class="nomessages">No message has been selected.</div>';
}

# Javascript based UI extension functionality

function extend_init(type)
{
	if(type==1 && window.js_extend_init_early)
		js_extend_init_early()
	if(type==2 && window.js_extend_init_late)
		js_extend_init_late()
}

function init_ui_elements()
{
	footer=dge('sw_footer').offsetHeight;
}


# ----------------------
# Implementation of client side panel "look and feel"
# valid: 'orig', 'plain', 'none'; 
var panel_mode='||panel_mode||';
var panel_gap=||panel_gap||;
function panelise()
{
	if (!pref.panelise) return;

#	Always round the corners of the status
	panelise_round(document.getElementById('status'),enBoth);

// Nothing at all panelised
	if(panel_mode=='none'){	
		panelise_none(document.getElementById('menubar'),enHdr);
		panelise_none(document.getElementById('lpanel_hdr'),enHdr);
		panelise_none(document.getElementById('messages'),util_body_style);
		panelise_none(document.getElementById('lpanel_body'),enBody);
		panelise_none(document.getElementById('app_menu'),enHdr);
		panelise_none(document.getElementById('contacts'),enHdr);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_none(o,enPlain);
		panelise_none(document.getElementById('sw_footer'),enBot);

# Left column not panelised
	}else if (panel_mode=='plain') { 
		panelise_plain(document.getElementById('lpanel_hdr'),enHdr2);
		panelise_plain(document.getElementById('lpanel_body'),enBody2);
		panelise_plain(document.getElementById('app_menu'),enBody2);
		panelise_plain(document.getElementById('contacts'),enHdr2);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_none(o,enPlain);
#		Center column and status
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_plain(document.getElementById('messages'),util_body_style);
		panelise_plain(document.getElementById('sw_footer'),enBot);
	
#	Original design
	}else{
#		Left column panels
		panelise_roundtop(document.getElementById('lpanel_hdr'),enHdr);
		panelise_square(document.getElementById('lpanel_body'),enBody);
		panelise_round(document.getElementById('app_menu'),enHdr);
		panelise_round(document.getElementById('contacts'),enHdr);
		var o=document.getElementById('custom_lpanel'); if (o) panelise_square(o,enPlain);
#		Center column and status
		panelise_roundtop(document.getElementById('menubar'),enHdr);
		panelise_square(document.getElementById('messages'),util_body_style);
		panelise_square(document.getElementById('sw_footer'),enBot);
	}
}

# Add new custom panels on the left
var panel_ids=1;
function new_panel_basic(content_body, top)
{
	var a=new_anchor_before("foobar", top=='top'?"lpanel_hdr":"contacts");
	a.className="left_pane";
	a.innerHTML='<div style="background:||lpanel_color||;padding:3px;">'+content_body+'</div>';	
	if(panel_mode=='orig'){
		panelise_round(a,enBoth);
	}else if(panel_mode=='plain'){
		panelise_plain(a,enBody2);
	}else{
		panelise_none(a,enBoth);
	}
}
function new_panel_fancy(content_header, content_body, top, plain)
{		
	var a=new_anchor_before("foobar", top=='top'?"lpanel_hdr":"contacts");
	a.className="left_pane";
	a.innerHTML='<div class="left_panel_header"> <span style="padding-left:5px">'+content_header+'</span></div><div style="background:white;'+(plain==true?'':'padding:3px;')+'">'+content_body+'</div>';
	var xhdr=a.firstChild;
	var xbody=a.firstChild.nextSibling;
	if(panel_mode=='orig'){
		panelise_roundtop(xhdr,enHdr);
		panelise_square(xbody,enBody);
	}else if(panel_mode=='plain'){
		panelise_plain(xhdr,enHdr2);
		panelise_plain(xbody,enBody2);
	}else{
		panelise_none(xhdr,enHdr);
		panelise_none(xbody,enBody);
	}
}

// Possibly combine this function with some of our own background downloads
function prefetch_init(msgs)
{
	flash_embedSWF2("||www_base||shared/modules/flash_audio.swf?||vz||");

	download_contacts();
	download_dialogs();
	cache_inbox(msgs);
	prefetch_images();
	refresh_flds();
	
	sw.done_prefetch=true;
#	var head = document.getElementsByTagName('head')[0];
#	var node = document.createElement('embed');
#	head.appendChild(node);
#	node.setAttribute('src', url);
}

var prefetch_img_urls=['img/dlg_alert.png','img/gradient.gif','img/dlg_confirm.png'], 
	prefetch_img_images=[];
function prefetch_images()
{
	for(var i=0;i<prefetch_img_urls.length;i++){
		prefetch_img_images.push(new Image());
		prefetch_img_images[i].src=wwwbase+prefetch_img_urls[i];
	}	
}


function cache_inbox(msgs)
{
	if (pref['nocache'] || msgs.length==0) return;

	if (done_cache) return;

	done_cache=true;
	ajax_cache_messages(msgs);	
}



function download_contacts()
{
	queued_req_add( enBG, function(){
		sndReq('cmd=show&page=~contacts.js', function(chan){
			var success
			success=actionReqJsStat(chan);
#				contact_error();
		},ch[enBG]);
	});
}

function download_dialogs()
{
	queued_req_add( enBG, function(){
#		sndReq('cmd=show&page=~dialogs.htm&dialog=contact_picklist', function(chan){			
		sndReqCached('cmd=show&page=~dialogs.htm&dialog=contact_picklist&if=ajax&static=||web_ref_path||', function(chan){			
			new_anchor('div',chan.responseText);			
			cp_init();
		},ch[enBG]);
	});
}

function refresh_flds()
{
	queued_req_add( enBG, function(){
		sndReq('cmd=folders_refresh,show&page=~result.js', function(chan){
#			var success=actionReqJsStat(chan);
		},ch[enBG]);
	});
}



# Setup live andmin interface refresh possibilities
#var live_url;
#var live_master;
#function live_refresh(win,url,just_reload)
#{
#	if(just_reload){
#		setTimeout(do_reload,150);
#	}else{
#		setTimeout(function(){document.location.href=url},150);
#	}
#	return;
#	if (win) live_master=win;
#	if (url) live_url=url;
#	if(!live_master || !live_master.live_update || !live_master.foobar) setTimeout(live_refresh,500);
#	live_master.live_refresh_cb(window,live_url);
#}




function info_panel_init()
{
	if(info_panel.length>0)
		new_panel_basic(info_panel,'top');
}

function prcc_new_attach(node,attach)
{
	// If we are adding it after popin / out then RESET the jmsg count here
#	node.jmsg.attach_ids=[];	
	for(var i=0;i<attach.length;i++){
		attach_myfile(node,attach[i]);
	}
}

function attach_myfile(node,att)
{
	var o=node.jmsg.attach_mid=att[0];

	var file={};
	file.id='myattach-'+att[0]+'-'+att[1];
	file.name=att[2];
	var progress = new FileProgress(file, node.swfu.customSettings.progressTarget,(node.jmsg.action=='redirect'));


	progress.setComplete();
	attachment_add(node,att);
	attachment_status(node.attach_status,node.jmsg.attach_ids);

	progress.fileProgressWrapper.sw_id=att[1];
	progress.setStatus(att[3]);
	progress.toggleCancel(true, node.swfu);
}

var g_new_attach=[]; //attach_mid, g_attach_id;
function upload_results(att) //attach_mid,attach_id)
{
#	dbg('results: '+att.length+' attachments');
	g_new_attach=att;
}
#function upload_results2(atts)
#{
#	for(i=0;i<atts.length;i++){
#		attach_myfile(atts[i]);
#	}
#}


function switch_selfld(fid)
{
	var el;
	var old_fid=sw.fid;

	sw.fid=fid;
	var txt_fid=fid;
	if (txt_fid=='INBOX') txt_fid='Inbox';

	document.getElementById("foldername1").innerHTML=txt_fid;
	document.getElementById("foldername2").innerHTML=txt_fid;
	el=document.getElementById("foldername_tab");
	if (el) el.innerHTML=txt_fid;

	el=dge('unread_'+old_fid);
#	if (el) class_remove(el.parentNode,"selfld");
	if (el) class_remove(ancestor_by_class(el,'full_cursor'),"selected");
	el=dge('unread_'+fid);
#	if (el) class_add(el.parentNode,"selfld");
	if (el) class_add(ancestor_by_class(el,'full_cursor'),"selected");
}

function column3_init()
{
	if(column3.length>0 && column3!='none'){
		right_column=||right_column_width||+panel_gap+2;
		var x=document.getElementById('right_column');
		class_remove(x,'hidden');
	}
# the below does not work ??	
#	dge('right_column').innerHTML=''+
#	  	'<span style="font-size:10px">advertisement</span>'+
#	  	<div style="border:1px solid ||border_color||;width:120px;height:600px;text-align:left;"><div style="padding:3px">Div for <br>arbitrary use: <br> - Information <br> - hints <br> - advertising??</div></div>
#	  	'<div style="border:1px solid ||border_color||;width:120px;height:600px;text-align:left;">||ad2_html||</div>';
#	alert('||ad2_html||');
}


function user_cgi_dlg(type)
{
#	x_alert('User_cgi dialog of type: '+type);
	var cmd='cmd=doauto_login&product=usercgi&sid='+sid; //&type=blogs
	var txt='Serverside email filtering';
	var extra='&combine_spam_friends=true'
			+ '&rating_probable='+ pref.rating_probable+'&rating_certain='+pref.rating_certain
			+ '&spam_hide_advanced='+pref.spam_hide_advanced+'&use_late='+usercgi_status['use_late'];

	switch(type){
		case 'responder': 	
		case 'forwarding':
		case 'filtering':
		case 'whitelist':	
		case 'spam': 		
		case 'friends':
							cmd+='&type='+type+extra; break;
#		case 'responder': 	cmd+='&lcmd=user_load_fwd&show=sw_respond.htm'+extra;break;
#		case 'forwarding': 	cmd+='lcmd=user_load_fwd&show=sw_fwd.htm'+extra; break;
#		case 'filtering':	cmd+='lcmd=user_load_exceptions&show=sw_filters.htm'+extra; break;
#		case 'whitelist':	cmd+='lcmd=user_load_friends&show=sw_whitelist.htm&cmd_user_load_friends=Address+list'+extra; break;
#		case 'spam': 		cmd+='lcmd=user_spam_load&show=sw_spam.htm'+extra; break;
#		case 'friends': 	cmd+='lcmd=user_load_fcommon&show=sw_unknown1.htm'+extra; break;
		case 'log': 
							cmd+='&type='+type; break;
#			txt='Mail delivery processing';		
#			cmd+='lcmd=user_load_log'; 
#			break;
		case 'raw': 
			txt='Raw user.cgi interface';		
			cmd+='lcmd='; 
			break;
	}
	
	if(type!='raw')
		cmd+='&surgeweb=true';
		
	cmd+='&utoken='+utoken;
	x_custom_dlg2(txt+' (user.cgi in a dialog) ',
#				 '<iframe src="'+backend+'cgi/user.cgi?'+cmd+'" style="width:100%;height:'+px(ClientHeight()*0.9-100)+'"></iframe>',
				 '<iframe src="'+cgibase+cmd+'" style="width:100%;height:'+px(ClientHeight()*0.9-100)+'"></iframe>',
		function(btn){
#			x_custom_dlg2 messes up the standard dialog so much that it is no longer easily reusable so remove completely
			dlg_reset();
#			if(!btn) return;
			usercgi_summary();
	});
}

function user_cgi_popup(type)
{
#	open_popup2(backend+'cgi/user.cgi?utoken='+utoken+type);
	open_popup2(cgibase+'cmd=doauto_login&product=usercgi&type=&sid='+sid);
}

function subject_init(){
	var ctl=sw.active.field_subject; 
	add_event(ctl,'blur',function(){
		set_tab_text(ctl.value.length>0?ctl.value:'New message');
	});
}


// see: get_addresses_sw for dialog outer prefetch
//		show_contacts for dialog initialisation

# *** msglist D&D :-)
var UA = navigator.userAgent.toLowerCase();
isFFok = UA.indexOf('firefox/3') != -1;
isIEok = UA.indexOf('msie 7') != -1 || UA.indexOf('msie 8') != -1;
Browser = {isIE  : isIEok, isIE6 : false, isIE7 : true, isIE8 : false, isFF: isFFok};
Loc = {isBidi : false, LEFT : "left",RIGHT : "right",LRM : "\u200e",RLM : "\u200f"};

var dnd;
function msgdnd_init(){
    if(dnd) { dnd.dispose(); dnd=null; }
    DND.RegisterDropTarget(dge("folders").parentNode, dnd1dst_OnDragOver, dnd1dst_OnDragOut, dnd1dst_OnDragDrop);
	dnd=new DND(dge('messages_list'), dnd1src_OnDragStart, dnd1src_OnDragEnd, dnd1src_OnNoTarget);	
}

function dnd1src_OnDragStart(jc,o){
	dbg("CUSTOM D&D dragstart");
    o.data = {validStart: false};
	var row=ancestor_by_class(o.overElement,'msgs_line');
	if (!row) return;
	var cell=ancestor_by_tag(o.overElement,'td');
	if(cell==row.childNodes[0] || cell==row.childNodes[1]) return;

	if (!class_contains(row,'selected')) {
		if(!(event.ctrlKey|| event.ctrlKey))
			select_none_fast();
		if (event.shiftKey && shift_sel_start){
			complete_selection(row,true);
		}else{
			row_select(row,true);		
		}
	}

	var sel=find_sel(true);
	if (!sel) return false;

    o.data = {validStart: true, sel: sel, toDiv: null, copy: event.ctrlKey };
	for_each_msg(o.data.sel,'pending');
    dnd1_iconCreate(o.data,sel.sel_all?sw.nav_total:sel.length);
    dnd1_iconUpdate(o.data,false);
}
function dnd1src_OnDragEnd(jc,o){
    var d = o.data;
    if (!d.validStart) return;
	dbg('CUSTOM D&D dragend (***) end='+log_element(o.fromElement)+' to='+log_element(o.toElement));
	
	if(!o.success || d.copy)
		for_each_msg(o.data.sel,'nopending');
	dnd_iconRemove(d.drag_div);
	for (var i=0;i<collapse_restore.length;i++){
		fld_expand(undefined,undefined,collapse_restore[i]);
	}
	collapse_restore=[];
} 
function dnd1src_OnNoTarget(jc,o){
    var d = o.data;
    if (!d.validStart) return;
    dnd1_iconUpdate(o.data,false,true);
}
var collapse_timer, collapse_restore=[];
function dnd1dst_OnDragOver(jc,o){
    var d = o.data;
#    var el = ancestor_by_att(o.overElement, "fid");
    var el = ancestor_by_class(o.overElement, "full_cursor");
#    dbg('do valid='+d.validStart+el_info(el)+'[['+el_info(o.overElement)+']]');
    if (!el || !d.validStart) {
        if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
        d.toDiv = null;
	    dnd1_iconUpdate(d,false);
        return;
    }
    dnd1_iconUpdate(d,true);
    if (el == d.toDiv) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    if (el.id == d.currFid) {
        d.toDiv = null;
        return;
    }
    d.toDiv = el;
	class_add(d.toDiv,'dnd_sel');
	
	if(collapse_timer){
		clearTimeout(collapse_timer);		
		collapse_timer=null;
	}
	if(class_contains(el.parentNode,'closed')){
		var node=el.parentNode;
		collapse_timer=setTimeout(function(){
			fld_expand(undefined,undefined,node);
			DND._UpdateDropTargetRegions();
			collapse_restore.push(node);
		},1000)
	}
}
function dnd1dst_OnDragOut(jc,o){
    var d = o.data, fld = d.toDiv;
    if (!d.validStart) return;
   	dnd1_iconUpdate(d,false);
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    d.toDiv = null
    clearTimeout(collapse_timer);
    collapse_timer=null;
}
function dnd1dst_OnDragDrop(jc,o){
    var d = o.data;
    if (!d.toDiv || !d.validStart) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');

	dbg('Actioning message DND '+(d.copy?'COPY':'MOVE')+' to folder ['+fid+']');
	var fid=d.toDiv.parentNode.getAttribute('fldid')
    if(d.copy){
		set_status("Copying...","info");
		ajax_msg_copy(d.sel,fid);
	}else{
		set_move_status(d.sel,fid);
		ajax_msg_move(d.sel,fid);
		do_select('none');
		message_done_action(d.sel);
	}        
    o.success = true
}


var dnd2;
function dnd2_init(){
    if(dnd2) { dnd2.dispose(); dnd=null; } 
    DND.RegisterDropTarget(dge("cm_groups"), dnd2dst_OnDragOver, dnd2dst_OnDragOut, dnd2dst_OnDragDrop);
	dnd2=new DND(dge('cm_contacts'), dnd2src_OnDragStart, dnd2src_OnDragEnd, dnd2src_OnNoTarget);	
}

var hack_nosize=false;
var hack_el;
function dnd2src_OnDragStart(jc,o){
	dbg("CUSTOM D&D dragstart");
    o.data = {validStart: false};
	var el=ancestor_by_class(o.overElement,'cm_contact');
	if (!el) return;
	var c=address_book.data[el.getAttribute('cm_cid')];
	if (!class_contains(el,'selected')) cm_select_contact(el,event);
    o.data = {validStart: true, sel: el, toDiv: null, fromDiv: el, c: c };
    dnd2_iconCreate(o.data,1);
    dnd2_iconUpdate(o.data,false,undefined,dnd2_ToIconText(c,undefined));
#    if (c.webmail || c.shared || c.isgroup) {
	if(!contact_editable(c)){
    	o.data.nodrag=true;
    }
    o.data.do_shared=c.shared;
    hack_nosize=true;
}
function dnd2src_OnDragEnd(jc,o){
    var d = o.data;
    if (!d.validStart) return;
	dbg('CUSTOM D&D dragend (***) end='+log_element(o.fromElement)+' to='+log_element(o.toElement));
	dnd_iconRemove(d.drag_div);
    hack_nosize=false;
} 
function dnd2src_OnNoTarget(jc,o){
    var d = o.data;
    if (!d.validStart) return;
    dnd2_iconUpdate(o.data,false,true);
}

function dnd2_ToIconText(c,g,el,id)
{
	if(!contact_editable(c)){
    	return 'This type of contact cannot be organised in your personal addressbook<br>(includes shared, webmail and groups)';
    }
	if(id=='all') return 'Already part of All Contacts';
	if(!g) return 'Adding to group';
	if(g.webmail) return 'Cannot modify webmail addresbook'
	
	if(g.shared && !c.shared){
		return 'Cannot add personal contact to shared groups';
	}else if(c.shared && !g.shared){
		return 'Cannot add shared contact to personal groups';
	}else if (el && class_contains(el,'selected')){
		return 'Already part of '+g.name+' group';
	}else{			
		return 'Adding to group '+g.name;
	}
}

function dnd2dst_OnDragOver(jc,o){
    var d = o.data;
    var el = ancestor_by_class(o.overElement, "cm_group");
#    dbg('do valid='+d.validStart+el_info(el)+'[['+el_info(o.overElement)+']]');
	if (el) {
		var id=el.getAttribute('cm_gid');
		var g=address_book.groups[id];
	}
#    if (!el || !d.validStart || id=='all' || d.nodrag || address_book.groups[id].webmail || (address_book.groups[id].shared && d.do_shared)) {
    if (!el || !d.validStart || id=='all' || d.nodrag || g.webmail || (g.shared && !d.c.shared) ) {
        if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
        d.toDiv = null;
	    dnd2_iconUpdate(d,true,undefined,dnd2_ToIconText(d.c,g,el,id));
        return;
    }
    dnd2_iconUpdate(d,true,undefined,dnd2_ToIconText(d.c,g,el,id));
    if (el == d.toDiv) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    if (el.id == d.currFid) {
        d.toDiv = null;
        return;
    }
    d.toDiv = el;
	class_add(el,'dnd_sel');
}
function dnd2dst_OnDragOut(jc,o){
    var d = o.data, fld = d.toDiv;
    if (!d.validStart) return;
   	dnd2_iconUpdate(d,false);
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');
    d.toDiv = null
}
function dnd2dst_OnDragDrop(jc,o){
    var d = o.data;
 	if (!d.toDiv || !d.validStart) return;
    if (d.toDiv) class_remove(d.toDiv,'dnd_sel');

	var cid=d.fromDiv.getAttribute('cm_cid');
	var gid=d.toDiv.getAttribute('cm_gid');

	dbg('Actioning contact DND add to group ['+gid+']');
	cm_contact_add2group(cid,gid)
    o.success = true
}


function dnd_iconRemove(a) { 
	document.body.removeChild(a.parentNode);
};
function dnd1_iconCreate(d,count)
{
	var a=new_anchor('div','<div class="dnd_info"><span>'+(event.ctrlKey?'Copying':'Moving')+'</span> '+count+' Message'+(count>1?'s':'')+'</div>');
    d.drag_div = a.firstChild;
    d.style = d.drag_div.style;
    d.xoffset = Loc.isBidi ? d.drag_div.offsetWidth : 0;
    d.copy=event.ctrlKey;
    return a.firstChild;
};
function dnd1_iconUpdate(d,ok,bad)
{
    if (d.validStart) {
        d.style.top = px(event.clientY + 20);
        d.style.left = px(event.clientX + (Loc.isBidi ? -10 : 10) - d.xoffset);
		if(ok){
			class_add(d.drag_div,"dnd_drop");
			class_remove(d.drag_div,"dnd_bad");
		}else if(bad){
#			// A slightly nasty test, but allows us to modify cursor without major changes to core DND code :-)
			if(document.body.style.cursor=='pointer'){
				class_remove(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}else{			
				class_add(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}
		}
		if(d.copy!=event.ctrlKey){
			d.drag_div.firstChild.innerHTML = (event.ctrlKey?'Copying':'Moving');
			d.copy=event.ctrlKey;
		}
    }
};
function dnd2_iconCreate(d)
{
	var a=new_anchor('div','<div class="dnd_info"></div>');
    d.drag_div = a.firstChild;
    d.style = d.drag_div.style;
    d.xoffset = Loc.isBidi ? d.drag_div.offsetWidth : 0;
    return a.firstChild;
};
function dnd2_iconUpdate(d,ok,bad,txt)
{
    if (d.validStart) {
        d.style.top = px(event.clientY + 20);
        d.style.left = px(event.clientX + (Loc.isBidi ? -10 : 10) - d.xoffset);
		if(ok){
			if(txt.indexOf('Adding to group')!=-1){
				class_add(d.drag_div,"dnd_drop");
				class_remove(d.drag_div,"dnd_bad");
			}else{
				class_add(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}
		}else{
#			// A slightly nasty test, but allows us to modify cursor without major changes to core DND code :-)
			if(document.body.style.cursor=='pointer'){
				class_remove(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}else{			
				class_add(d.drag_div,"dnd_bad");
				class_remove(d.drag_div,"dnd_drop");
			}
		}
	}
	if (txt) d.drag_div.innerHTML = txt;
};

# ****

function default_font_size()
{
	if (sw.is_popup)
		return sw_win.font_size;
	else
		return font_size;
}

function newmsg_refresh_allowed()
{
	if (sw.fid!="INBOX") return false;
	var sel=find_sel(true);
	if (sel && sel.length>1) return false;
	if (sw.search_input && sw.search_input.valid) return false;
	if (sw.nav_first>1) return false;
	return true;
}
function delayed_refresh(fn)
{
	if(!newmsg_refresh_allowed()) return false;
#	return true;
	setTimeout(function(){
			var sel=find_sel(true);
			var pending=find_pending();
			if(!sel || sel && sel.length==1)
				fn();
			for_each_msg(pending,'pending');
			msglist_select(sel?sel[0]:first_message);
		},120);
	return true;
}

function plural(len){
	return len>1?'s':'';
}
function set_from(node,val)
{
	node.value=val;
	node.nextSibling.innerHTML=encode_lt_gt(val);
}
var popup_spellcheck;
function spellchecker_said(o)
{
	if(!o || o.length==0) {
		set_status('Spellchecker found no mistakes','success');
		return;
	}
	var len=o.length;
	set_status('Spellchecker found '+len+' unknown word'+plural(len),"info");
	
	if(!popup_spellcheck || popup_spellcheck==window)
		check_spelling_cb(o)
	else
		popup_spellcheck.check_spelling_cb(o);
}

function msg_from_editor(node)
{
	var txt;
	if (node.sc){
#		// cleanup from spellchecker
		txt=node.sc.getTextToCheck()
	}else{
		txt=oddball_cleanup(node.field_eframe.contentWindow.document.body.innerHTML);
	}

	return txt;
}

function oddball_cleanup(txt)
{
#	Webkit browsers (safari etc) editor converts &nbsp; to high end characters, so convert back. OK to do for all browsers
#	if (isSafari);
	txt = txt.replace(/\u00A0/g, '&nbsp;');
#	Opera sends odd things like \r\r and \r which serverproceesing does not like, as \r characters get 
#	junked during serverside processing anyway lets just outright remove them for all browsers
	txt = txt.replace(/\r/g, '');

	return txt;	
}
//	just do a savedraft with integral spellcheck ;-)
function main_message_spellcheck(iid)
{
    var iid=sw.active.instance;
    var win=sw.active.field_eframe.contentWindow;
    
    var SC = Spell.getInstance(iid);
    if (!SC) {
        SC = new Spell(iid, win);
        sw.active.sc=SC;
		add_event(win.document,"mousedown", editor_mousedown);
		win.document.oncontextmenu=editor_contextmenu;
		document.oncontextmenu=editor_contextmenu;
		
#		win.document.onmousemove=function(e){dbg("++MOVE & forwarding target="+target(e).tagName);xx_menu.dispatchEvent(e)}
#		win.document.onmousemove=function(){dbg("++MOVE")}
#		win.document.onselectstart=function(){if(no_edit_contextmenu_once) return false;};
    }
	sw.run_spellcheck_once=true;
	do_save_draft(undefined,function(){sw.active.unsaved=false});
	
#	document.oncontextmenu=new Function("return false;")
}
function check_spelling_cb(o)
{
    var iid=sw.active.instance;
    var SC = Spell.getInstance(iid);
    if (!SC) return;
    
    SC.correctAll(true, null, true);
   
	SC.ajaxResultApply(o);
#	SC.g8(aa());			// Setup language related stuff
	SC.highlightWords();
}
function ed_spell_check_x1(e)
{
	var el=target(e);
	if (!class_contains(el,'mark')) return;
    var SC = Spell.getInstance(sw.active.instance);
//	SC.correctAll(true, null, true);
#	var el=xdoc.getElementById('misspell-1');
	return SC.showElementsMenu(el)
//	SC.showMenu(el)
}

function spellcheck_markup_remove(e)
{
    var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return;

    var el = SC.bothRangeFn(e);
    var id = el ? el.id : null;

	SC.applyCorrection(el);

	// Just remove them all for now!!
//	SC.correctAll(true, null, true);
//	SC.applyCorrection(target(e),true);
}

function spellcheck_markup_removeall(flag)
{
	if(flag!=undefined && flag!=true) return;
    var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return; 
    SC.correctAll(true, null, true);
}
function editor_mousedown(e)
{
	if(ed_spell_check_x1(e)){
		no_edit_contextmenu_once=true;
		stopEvent(e);
		return false;
	}
}

function spell_menu_click(e)
{
	if(!e) e=window.event; 
 	var SC = Spell.getInstance(sw.active.instance);
    if(!SC) return;

	var el=target(e);
	if(!el) return;
	var mnu=ancestor_by_class(el,"xmenu");	
	var tag=el.tagName.toLowerCase();
	if(tag!='a') el=el.parentNode;

	switch(el.getAttribute("cmd")){
		case 'spell_menu_correct':
			SC.applyCorrection(mnu.el,true,el.innerHTML);
			break;
		case 'spell_menu_ignore':
			SC.applyCorrection(mnu.el,true);
			break;
		case 'spell_menu_learn':
			learn_word(mnu.el.innerHTML);
			SC.applyCorrection(mnu.el,true);
			break;
	}
	menu_hide2(mnu)
	no_edit_contextmenu_once=true;
	stopEvent(e);
	return false;
#    SC.correctAll(true, null, true);
}
var no_contextmenu_once=false;
function main_contextmenu(e)
{
	if(no_contextmenu_once){
		no_contextmenu_once=false;
		return false;
	}
}

var no_edit_contextmenu_once=false;
function editor_contextmenu(e)
{
	if(no_edit_contextmenu_once){
		no_edit_contextmenu_once=false;
		return false;
	}
}
function folder_click(e)
{
	if(!e) e=window.event;
	var t=target(e);
	var row=ancestor_by_tag(t,'li');
	if (class_contains(row,'fake')){		
		fld_expand(undefined,undefined,row);
		if(row.childNodes.length==1){
			manage_folders(e);
		}
		return;
	}
	F(row.getAttribute('fldid'),row.getAttribute('fld_type'));	
}
function full_cursor2link(el)
{
	return el.childNodes[2].childNodes[0];
}

function learn_word(txt)
{
	queued_req_add( enQ, function(){
		sndReq('cmd=spellcheck_learn,show&page=~result.js&new_word='+xescape(txt), function(chan){
			var success=actionReqJsStat(chan);
			if(success){
				set_status('Spellchecker learnt "'+txt+'"',"success");
			}else{
				set_status('Learn failed ('+success_string+')','warning');
			}
		},ch[enQ]);
	});
}
function check_version(ver)
{
	if(ver==version||version==undefined) return true;
	set_status('Server upgraded! (save and relogin)','warning');
	x_alert('WARNING: The server has been upgraded - please save your work, logout, and then login again to make sure everything works correctly.');
	version=undefined;
	return false;
}


# Create a "jmsg" object ie. javascript message object that lasts until the message is successfully sent or message is discarded
# lives in the context of the main window even for popup windows so it does not need to cloned
function compose_jmsg(eml)
{
	var jmsg=new Object();
	jmsg.to=eml;jmsg.cc=[];jmsg.bcc=[];
	jmsg.sel_mids=[]
	jmsg.params=jmsg.subject=jmsg.msg_html=jmsg.cache_mid=jmsg.fld='';
	jmsg.action='compose';
	return jmsg;
}
function jmsg_reset(jmsg)
{
	jmsg.cb=jmsg_check_ready;
	jmsg.msg_html='';
}
function sel_to_jmsg(sel, action)
{
	var jmsg=new Object();
	dbg('sel_to_jmsg '+action);

#	// Automatically switch "forward" to "forward attach" for multiple messages
	if (sel.length>1 && action=='forward') action='forward_attach';

#	// The bare minimum information we need to identify a message :-)
	jmsg.action=action;
	jmsg.fld=sw.fid;		// really source folder & type
	jmsg.fld_type=sw.fld_type;	
	jmsg.cache_mid=sel[0];
	jmsg.sel_mids=sel;
	
# 	// Now actually get the message details if we have it
	if(!sw_cache[jmsg.fld+'_'+jmsg.cache_mid]){
		dbg('don\'t actually have the source message yet so setting up callback to poll later');
		jmsg.cb=jmsg_check_ready;
		return jmsg;
	}

	if (action=='view') return jmsg;

	return jmsg_complete(jmsg);
}
function jmsg_check_ready(jmsg)
{
#	dbg('QQQQ 2c sw.fid='+sw.fid+'['+jmsg.fld+'] sw.mid'+sw.mid+'['+jmsg.cache_mid+']');
	var idx=jmsg.fld+'_'+jmsg.cache_mid;
	if(!sw_cache[idx]) return false;
	if(jmsg.action=='view') return true;
	jmsg_complete(jmsg);
	return true;
}
function jmsg_complete(jmsg)
{
	var action=jmsg.action;

	qmsg=sw_cache[jmsg.fld+'_'+jmsg.cache_mid];
	if(!qmsg) {alert('msg error, should never get here!!');return jmsg;}

	var from=cloneObject(qmsg.data['from']);
	var to=cloneObject(qmsg.data['to']);
	var cc=cloneObject(qmsg.data['cc']);
	var reply_to=cloneObject(qmsg.data['reply_to']);

	jmsg.subject=qmsg.data['subject'];
	jmsg.date=qmsg.data['date'];

	jmsg.nattach=val_int(qmsg.data['attachments']);
	
#	// Work out what part of the old message body to display
	if(action=='edit' || action=='redirect'){
		jmsg.msg_html='';
	}else{
		jmsg.msg_html='--- Original message ---'
				+' <br>Subject: '+encode_lt_gt(jmsg.subject)
				+' <br>From: '+rcpts_as_html(from)
				+' <br>To: '+rcpts_as_html(to)
				+(cc.length>0 ? ' <br>Cc: '+rcpts_as_html(cc) : '')
				+' <br>Date: '+jmsg.date+'<br><br>';
	}
	jmsg.msg_html+=qmsg.msg_html;
	if(action=='forward_attach') jmsg.msg_html='';

#	// Now work out addressing	
	if (action=='redirect') to=[];
	jmsg.cc=[];
	jmsg.bcc=[];	
	if (action=='reply' || action=='replyall'){
		if (jmsg.subject.substring(0,3).toLowerCase()!="re:") jmsg.subject='Re: '+jmsg.subject;
		jmsg.to=(jmsg.fld_type==enSent?to:reply_to);
		if(action=='replyall'){		
			jmsg.cc=to;
			if(cc.length>0) jmsg.cc=jmsg.cc.concat(cc);
		}
	}else if ((action=='forward') || (action=='forward_attach')) {
		if (jmsg.subject.substring(0,4).toLowerCase()!="fwd:") jmsg.subject='Fwd: '+jmsg.subject;
		jmsg.to=[];
	}else{
#		Re-edit a draft or other message etc
		jmsg.to=to;
		jmsg.cc=cc;
		jmsg.not_new=true;
		jmsg.edit_uid=jmsg.cache_mid;
	}
	return jmsg;
}


// See [function ajax_send]
// Used to be [function msg_for_sending(node)]

function jmsg_update(node)
{
#	Make sure allocs are donw in the context of the main window	
	if(sw.is_popup) return sw_win.jmsg_update(node);

	var jmsg=node.jmsg;
	if (!jmsg) {alert('badness');return;}
	
	jmsg.to=fancy_edit_value(node.field_to);
	jmsg.cc=fancy_edit_value(node.field_cc);
	jmsg.bcc=fancy_edit_value(node.field_bcc);
	jmsg.subject=node.field_subject.value;
	jmsg.msg_html=msg_from_editor(node);

#	// Possibly want to make this selectable somehow	old: [node.field_from.value]
	jmsg.from=[work_out_from()];	

	jmsg.params='&to='+rcpts_as_param(jmsg.to)+'&cc='+rcpts_as_param(jmsg.cc)+'&bcc='+rcpts_as_param(jmsg.bcc)
				+'&from='+rcpts_as_param(jmsg.from)+'&subject='+xescape(jmsg.subject);
	
#	// Easiest to ensure this is done here
	if(jmsg.attach_ids){
		jmsg.attach_ids=cloneObject(jmsg.attach_ids);

		if(jmsg.attach_ids.length>0){
			jmsg.params+='&attach_mid='+jmsg.attach_mid+'&attach_ids='+jmsg.attach_ids.join(',');
		}
	}
	if (jmsg.edit_uid){
		jmsg.params+='&edit_uid='+jmsg.edit_uid;
	}

	// Turn this into or conditions??
	jmsg.from_popup=node.is_popup;
	jmsg.node=node;
	
	return jmsg;
}
function main_window_check(node)
{
	var ok;
#	// try catch based check (I can't think of anything nicer for now) 
	try{var dummy=node.jmsg.to; ok=true;}catch(e){ ok=false;}

	if(!ok || !window.opener || window.opener.closed){
		alert('WARNING: Main SurgeWeb window unavailable - you must leave this open while you are using surgeweb.\n\n Copy and paste message text from here to save your work.');
		return false;
	}
	
	return true;
}
function read_attached_msg(part)
{
	alert('want to show '+part);
#	show_message(??? , part);
}
// cmd=show&page=~msg.js&msg_id=110267&fld_id=INBOX&sid=2&if=ajax

function jmsg_display_class(jmsg){
	return (jmsg.action=='redirect'?'do':'no')+'redirect';
}

function compare_folders(fld1,fld2)
{
	if(fld1==fld2) return true;
	x_alert('You must have the '+fld1+' folder selected instead of '+fld2+' folder.');
	return false;
}
function bookmarking_init()
{
	window.onbeforeunload=function(e){
#		if(!sw.closing && class_contains(sw.active,'message'))
		if(!sw.closing && sw.active.unsaved)
			return 'Your message will be lost.';
	}
}
function fancy_edit_hidden(el)
{
	el=ancestor_by_class(el,'compose_hdr_row');	
	return class_contains(el,'hidden');
}
function focus_next_surgeweb_edit_ctl(el)
{
	var o=sw.active;
	var next;
	if(el==o.field_to)
		next=o.field_cc;
		
	if((el==o.field_cc) || (next==o.field_cc && fancy_edit_hidden(o.field_cc)))
		next=o.field_bcc;

	if((el==o.field_bcc) || (next==o.field_bcc && fancy_edit_hidden(o.field_bcc)))
		next=o.field_subject;

	if(el==o.field_subject)
		next=o.field_eframe.contentWindow;

	if(!next) return;

	next.focus();	
}

#var q=[]
#for (var i=0;i<100;i++)
#	q[i]='012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789';

function do_test()
{
#	benchmark_begin('1');
#	for (var i=1;i<10000;i++)
#		dbg(q[1]+q[2]+q[3]+q[4]+q[5]+q[6]+q[7]+q[8]+q[9]+q[0]);
#		dbg();
#	alert(benchmark_end('1'));
	
}
# Do one of several spam processing action: notspam, once, spam, block
function spam_info(type,fld,mid)
{
	if(!class_contains(sw.active,'fldmsg')){
		alert("sorry only available from preview pane for now");
		return;
	}
	if(sw.is_popup){
		sw_win.spam_info(type,fld,mid);
	}
	
	var sel=make_sel(fld,mid);
	ajax_spam_rating(sel,type,function(){});
	
#	// Do stuff dependant on location
	if(class_contains(sw.active,'fldmsg')){
		// preview
	}else if(sw.is_popup){
		// popup
	}else{
		// inline	
	}
}

function spam_rating_results(o)
{
	spam_rating_updates = o;
}

function misc_init(){
	do_stype(dge('pg_menu_search').firstChild,'quick');
	
	Dbg.report_cb=function(txt){
		x_prompt("This will send matching browser and server SurgeWeb debug logs to marijn@netwinsite.com. Please add a comment to identify the reason for sending this report :","comment",function(val){
			if (!val) return;
			var jmsg=compose_jmsg(['marijn@netwinsite.com']);
			jmsg.params='&to='+rcpts_as_param(jmsg.to)+'&subject='+xescape('SurgeWeb fault report')+'&attach_debug_log=true';
			jmsg.report=true;
			jmsg.msg_html=	'Fault reported by: '+work_out_from()+'<br>'+
							'Comment:'+val+'<br>'+
							'<br>'+
							'Surgweb browser log:<br>'+
							txt;
			ajax_send(jmsg);
		});
	}
}

# defined fuctions this way else some browsers do not allow you to call them
var map_sw_2_core, map_core_2_sw, map_ctls_to_ctl0, ctl0_mapping, ctl_text, ctl2_allow, extra_info;
var usercgi_status, usercgi_raw, usercgi_working;
var opt_xx=['respond','fwd_early','filter','whitelist','spam','unknown','fwd_late'];

function usercgi_summary()
{

	usercgi_status={'respond':'(unknown)', 'fwd_early':'(unknown)', 'filter':'(unknown)', 
					'whitelist':'(unknown)', 'spam':'(unknown)', 'unknown':'(unknown)',	'fwd_late':'(unknown)'};

	for(var i=0;i<opt_xx.length;i++){
		dge('filt_'+opt_xx[i]).innerHTML=usercgi_status[opt_xx[i]];
	}
	
	queued_req_add( enQ, function(){
		var url=backend+'cgi/user.cgi?cmd=auto_login%26lcmd=user_summary_info%26show=sw_summary.js%26utoken='+utoken;
		sndReq('cmd=proxy&add_auto_login=true&url='+url, function(chan){
#			// check validity of response... 
			var success=actionReqJsStat(chan);
			apply_summary_info();
		},ch[enQ]);
#		cgibase=tmp;
	});
}
#			var usercgi_status={
#					'respond':'ENABLED', 'fwd_early':'UNKOWN', 'filter':'STATUS', 'whitelist':'STATUS',
#					'spam':'<font color="green">ENABLED</font>', 'unknown':'<font color="red">DISABLED</font>', 'fwd_late':'STATUS'};

function set_ctl0(event,ctl)
{
	var onestep=ctl.value;

	ctl_dynamic_select(ctl,ctl0_options(ctl.value),ctl_text);
	ctl.value=onestep;
	ctl_dynamic_info(ctl);
	
	var state=ctl0_mapping[onestep];	
	map_sw_2_core(state[0],state[1],usercgi_working);
	
	var w=usercgi_working;
	var url=backend+'cgi/user.cgi?cmd=auto_login%26lcmd=user_spam_save%26combine_spam_friends=true%26lcmd_ex=user_summary_info%26show=sw_summary.js';
	url += '%26friend_mode='+w.friend_mode+'%26friend_smite='+w.friend_smite+'%26recent_out_auto='+w.recent_out_auto
			+'%26spam_subject='+w.spam_subject+'%26spam_body='+w.spam_body+'%26spam_bounce='+w.spam_bounce
			+'%26spam_ddpriv='+w.spam_ddpriv+'%26spam_ddfrom='+w.spam_ddfrom+'%26spam_store='+w.spam_store+'%26spam_vanish='+w.spam_vanish;

	sndReq('cmd=proxy&add_auto_login=true&url='+url, function(chan){
		var success=actionReqJsStat(chan);
		apply_summary_info();
	})
}

function apply_summary_info()
{
	var val;
	var lookup=[];
#	Do any complicated workigns out...
	
	if(usercgi_status['respond']=='not available'){
		set_status('User.cgi settings could not be updated (probably logged in from elsewhere - relogin to surgeweb)','warning');
		for(var i=0;i<opt_xx.length;i++){
			dge('filt_'+opt_xx[i]).innerHTML='(not available)';
		}
		return;
	}

	if(true){
		usercgi_working=cloneObject(usercgi_raw);	
		var state=map_core_2_sw(usercgi_working);
		var onestep=map_ctls_to_ctl0(state);
		ctl=dge("spam_onestep");
		ctl_dynamic_select(ctl,ctl0_options(onestep),ctl_text);
		ctl.value=onestep;
		ctl_dynamic_info(ctl);

#		alert(onestep+'<<<'+state.join(' '))

		switch(onestep){
			case 'disabled': 		val='disabled';break;
			case 'little_spam': 	val='markonly';break;
			case 'little_spam2':
			case 'lots_spam':
			case 'lots_spam2': 		val='enabled';break;					
			case 'child_account': 	val='kidsafe';break;
			default:				val='custom';break;
		}
		if(usercgi_working.spam_store>0 || usercgi_working.spam_vanish>0)
			val='warn';
		lookup['spam']=val;

		if(usercgi_working.friend_mode!='disabled'){
			if(usercgi_working.recent_out_auto=='checked')
				val='enabled';
			else
				val='part';
		}else{
			val='disabled';
		}
		lookup['whitelist']=val;

		switch(usercgi_working.friend_mode){
			case 'smite':
			case 'ask':	val='enabled'; break;
			case 'safe':val='kidsafe';break;
			default: val='disabled';break;
		}
		lookup['unknown']=val;				
	}
	for(var i=0;i<opt_xx.length;i++){
		if (!usercgi_status || !usercgi_status[opt_xx[i]]) continue;
		if(opt_xx[i]=='whitelist' || opt_xx[i]=='spam' || opt_xx[i]=='unknown'){
			val=usercgi_status[opt_xx[i]][lookup[opt_xx[i]]];
		}else{
			val=usercgi_status[opt_xx[i]];
		}
		dge('filt_'+opt_xx[i]).innerHTML=val;
	}
	if(usercgi_status['use_late']=='checked'){
		class_add(dge('forward_early'),'hidden');
		class_remove(dge('forward_late'),'hidden');
	}else{
		class_add(dge('forward_late'),'hidden');
		class_remove(dge('forward_early'),'hidden');
	}
	extra_info('extra_info2',usercgi_working);
	if(usercgi_status['g_imap_friends']=='false')
		class_remove(dge('warning_g_imap_friends'),'hidden');
}
function ctl0_options(val)
{
	var arr=['disabled','little_spam','little_spam2','lots_spam'];
	if (val=='child_account' || val=='custom') arr.push(val);
	return arr;
}